<?php
session_start();

// If they are not logged in
if(!isset($_SESSION['chat_user']))
	die;

// Be sure to update these upon name changes
$kicked_file = "chat/kicked_file.txt";
$banned_file = "chat/banned_file.txt";

// Check if the user has been kicked
if(in_array($_SESSION['chat_user'], file($kicked_file))) {
	require("functions.php");
	delete_message(array_search($_SESSION['chat_user'], file($kicked_file)) + 1, $kicked_file);	
}

// For each line in the file
foreach(file($banned_file) as $line_num => $line) {

	// If the line contains the session user
	if(strpos($line, $_SESSION['chat_user']." ") !== false) {
		// Remove spaces and insert each section into an array
		$line = explode(" ", $line);

		// The time they were banned, and how long they were banned for
		$ban_time = $line['1'];
		$how_long = $line['2'];

		// The formula to check the amount of minutes left in the ban
		$time_left = ceil(($ban_time + ($how_long * 60) - time()) / 60);

			// If the ban has expired, delete the line.
			if($time_left <= 0) {
				require_once("functions.php");
				delete_message(array_search($_SESSION['chat_user']." ".$ban_time." ".$how_long, file($banned_file)) + 1, $banned_file);
			}

	}

}


?>