<?php
// Function to delete a message
function delete_message($line_no = -1, $file) { 

	$strip_return = FALSE; 

	$data = file($file); 
	$pipe = fopen($file, 'w'); 
	$size = count($data); 

	if($line_no == -1)
		$skip = $size - 1; 
	else
		$skip = $line_no - 1; 

	for($line = 0; $line < $size; $line++) 

		if($line != $skip)
			fputs($pipe, $data[$line]); 
		else if($line == $skip)
			fputs($pipe, "\n");
		else
			$strip_return = TRUE;

	return $strip_return; 

} 

// Function to update chat settings
function chat_update($f, $f_all, $lim, $t) {

	require("../config.php");

	$file = fopen('../config.php', 'w') or die("Unable to write the config.php file.  Please check file permissions.");

	$contents = '<?php

define(\'CURRENT_VERSION\', "'.CURRENT_VERSION.'");

// Display message when there is a newer version of the script available? 0 = no 1 = yes
$display_v = '.$display_v.';

// Do you want to filter chat? yes = 1
$filter = '.$f.';

// Do you want the filter to not apply to only whole words. yes = 1
// If you filtered rain, and this is not set to 1, rain would be filtered, but a word like rainbow would be left alone.
// If it was set to 1, rain would be filtered, and the rain in rainbow would be filtered
$filter_all = '.$f_all.';

// How many posts do you want to limit the user to send within a 3 second period?
// To clarify, once a message is posted, the count is increased by 1.
// If another message is sent within a 3 second period, it increases again until your set limit, then the user is banned.
$post_limit = '.$lim.';

// How long would you like a chat ban to last?  In minutes.
$ban_time = '.$t.';

?>';
		
	fwrite($file, $contents);
		
	fclose($file);

}

// Function to filter chat
function filter($message, $wholeword = true) {

	$wordlist = array(
			  'ass'		=>	'***',
			  'bitch'	=>	'*****',
			  'cock'	=>	'****',
			  'cunt'	=>	'****',
			  'dick'	=>	'****',
			  'fuck'	=>	'****',
			  'fucker'	=>	'******',
			  'fucking'	=>	'*******',
			  'shit'	=>	'****',
			  'shitter'	=>	'*******',
			  'shitting'	=>	'********');

	foreach ($wordlist as $word => $filter) {

		$word = ($wholeword == true)? "/\b{$word}\b/i" : "/{$word}/i";
		preg_match_all($word, $message, $matches);

		foreach ($matches[0] as $bword) {

			$replacement = '';

			$count = strlen($filter);

			for ($pos = 0; $pos < $count; $pos++) {

				$replacement .= (strcasecmp($filter{$pos},$bword{$pos}) == 0)? $bword{$pos} : $filter{$pos}; 

			}

			$pattern = ($wholeword == true)? "/\b{$bword}\b/" : "/{$bword}/";  

			$message = preg_replace($pattern, $replacement, $message);

		}

	}

	return $message;

}

// Function to convert chat to bbcode
function bbcode($message) {

	// If the user attempted to make a link, and it does not begin with http://, we need to put http:// in to prevent linking to other parts the site.
	if(strpos($message, "[url=") !== false && strpos($message, "http://") === false && strpos($message, "[url=]") === false) {
		$message = str_replace("[url=", "[url=http://", $message);
	}

	$search = array(
                '/\[b\](.*?)\[\/b\]/is',                                
                '/\[i\](.*?)\[\/i\]/is',                                
                '/\[u\](.*?)\[\/u\]/is',
                '/\[url\=(.*?)\](.*?)\[\/url\]/is'
                );
 
        $replace = array(
                '<b>$1</b>',
                '<i>$1</i>',
                '<u>$1</u>',
                '<a href="$1" target="_blank">$2</a>'
                );
 
        $bb = preg_replace ($search, $replace, $message);
 
        return $bb;

}

// Function to send a chat message (only applies to a user if javascript is disabled)
function send_chat($name, $message) {

	require("config.php");

	$chat_file = "chat/chat_log.txt";
	$kicked_file = "chat/kicked_file.txt";
	$banned_file = "chat/banned_file.txt";

	// Check if they are kicked	
	if(in_array($_SESSION['chat_user'], file($kicked_file))) {
		header("Location: chat.php");
		die;
	}
			
	// For each line in the banned file
	foreach(file($banned_file) as $line_num => $line) {

		// If the line contains the session user
		if(strpos($line, $_SESSION['chat_user']." ") !== false) {
			header("Location: chat.php");
			die;
		}

	}
		
	$mess = explode(" ", $message);

	// If the user is trying to make an announcement and they are not an admin
	if(!isset($_SESSION['chat_admin']) || $_SESSION['chat_admin'] != 1) {
		if($mess['0'] == "/announce") {
			header("Location: chat.php");
			die;
		}
	}
		
	// Check if the user has tried to private message themself
        if(isset($mess['1'])) {
                if($mess['0'] == "/tell" && $mess['1'] == $_SESSION['chat_user']) {
		        header("Location: chat.php");
		        die;
                }

                if($mess['0'] == "/tell" && (!isset($mess['2']) || trim($mess['2']) == "")) {
                        header("Location: chat.php");
                        die;
                }
	}
    	 
	$nickname = htmlentities($_SESSION['chat_user'], ENT_QUOTES);
			
	// Emoticons
	$patterns = array(
		"/:\)/",
		"/:D/",
		"/;D/",
		"/;\)/",
		"/:\(/",
		"/:'\(/",
		"/;\(/",
		"/:P/",
		"/:p/",
		"/;P/",
		"/:o/",
		"/8\)/",
		"/:shy:/",
		"/:quiet:/",
		"/:kiss:/",
		"/:awkward:/",
		"/:wtf:/",
		"/:confused:/",
		"/:shrug:/",
		"/:facepalm:/",
		"/:facewall:/",
		"/:hammertime:/",
		"/:thumbup:/",
		"/:rolleyes:/",
		"/:ninja:/",
		"/:birthday:/",
		"/:rules:/"
			
		);
			
	// Emoticon Replacements
	$replacements = array(
		"<img src='css/images/emotes/happy.gif'/>",
		"<img src='css/images/emotes/happy02.gif'/>",
		"<img src='css/images/emotes/happy03.gif'/>",
		"<img src='css/images/emotes/wink.gif'/>",
		"<img src='css/images/emotes/sad.gif'/>",
		"<img src='css/images/emotes/cry.gif'/>",
		"<img src='css/images/emotes/mad.gif'/>",
		"<img src='css/images/emotes/tongue.gif'/>",
		"<img src='css/images/emotes/tongue02.gif'/>",
		"<img src='css/images/emotes/tongue03.gif'/>",
		"<img src='css/images/emotes/excl.gif'/>",
		"<img src='css/images/emotes/cool.gif'/>",
		"<img src='css/images/emotes/shy.gif'/>",
		"<img src='css/images/emotes/quiet.gif'/>",
		"<img src='css/images/emotes/kiss.gif'/>",
		"<img src='css/images/emotes/awkward.gif'/>",
		"<img src='css/images/emotes/wtf.gif'/>",
		"<img src='css/images/emotes/confused.gif'/>",
		"<img src='css/images/emotes/shrug.gif'/>",
		"<img src='css/images/emotes/facepalm.gif'/>",
		"<img src='css/images/emotes/facewall.gif'/>",
		"<img src='css/images/emotes/hammertime.gif'/>",
		"<img src='css/images/emotes/thumbup.gif'/>",
		"<img src='css/images/emotes/rolleyes.gif'/>",
		"<img src='css/images/emotes/ninja.gif'/>",
		"<img src='css/images/emotes/party.gif'/>",
		"<img src='css/images/emotes/rules.gif'/>"
				
		);

	$blankexp = "/^\n/";
	$message = htmlentities($message, ENT_QUOTES);
		
	$message = bbcode($message);
			
	// If the admin chooses to filter chat
	if($filter == 1 && $filter_all == 0)
		$message = filter($message);
	else if($filter == 1 && $filter_all == 1)
		$message = filter($message, false);

	// If the message is not blank
	if (!preg_match($blankexp, $message)  && trim($message) != "") {

		// Replace all necessary elements
		$message = str_replace("&#039;", "'", $message);
		$message = preg_replace("/javascript:/", "", $message);
		$message = preg_replace("/\/tell/", "&#47;tell", $message);
		$message = preg_replace("/&#47;tell/",  "/tell", $message, 1);
		$message = trim(preg_replace($patterns, $replacements, $message));
		$message = str_replace("\n", " ", $message);
    			 
		// Write to the file
		fwrite(fopen($chat_file, 'a'), $nickname." - ".$message."\n");  

		// If the user has posted a message within 2 seconds of their last
		if(isset($_SESSION['chat_posts']) && (time() - 2) < $_SESSION['chat_post_time']) {
			
			// Increment the posts and get the new post time
			$_SESSION['chat_posts'] = $_SESSION['chat_posts'] + 1;
			$_SESSION['chat_post_time'] = time();
				
			// If the user has posted the limit
			if($_SESSION['chat_posts'] == $post_limit) {
				
				// Remove the posts and post time
				unset($_SESSION['chat_posts'], $_SESSION['chat_post_time']);
					
				// Insert the ban
				fwrite(fopen($banned_file, 'a'), htmlentities($_SESSION['chat_user'])." ".time()." ".$ban_time."\n");
				fwrite(fopen($chat_file, 'a'), "System - /announce ".$nickname." has been banned for spamming.\n");

			}

		// If the user has posted a new message
		} else {

			$_SESSION['chat_post_time'] = time();
			$_SESSION['chat_posts'] = 1;

		}

	}

}

// Function to update a user password
function update_user($pass) {

	include("connect.php");

	$user = mysqli_real_escape_string($connection, $_SESSION['chat_user']);

	$sql = mysqli_query($connection, "UPDATE `chat_users` SET `pass` = '{$pass}' WHERE `user` = '{$user}'") or die("Unable to update your password.  Please contact an admin immediately.");

	header("Location: ../chat/logout.php");
	die;

}

// Function to login a user
function login($user, $pass) {

	include("connect.php");
	
	$sql = mysqli_query($connection, "SELECT * FROM `chat_users` WHERE `user` = '{$user}' AND `pass` = '{$pass}'") or die("Unable to login.  Please contact an admin immediately.");

	if(mysqli_num_rows($sql) != "0") {

                session_regenerate_id(true);

		while ($row = mysqli_fetch_object($sql))
		{
			$_SESSION['chat_user'] =	$row -> user;
			$_SESSION['chat_admin'] =	$row -> admin;
		}
		
		header("Location: ../chat.php");
		die;

	} else {
		header("Location: login.php?log=fail");
		die;
	}

}

// Function to register a user
function register($user, $pass) {

	include("connect.php");

	$sql = mysqli_query($connection, "INSERT INTO `chat_users` VALUES (
	'{$user}', 
	'{$pass}',
	'0')") or die("Unable to register.  Please contact an admin immediately.");

	header("Location: login.php?reg=new");
	die;

}

// Please leave this function alone
function get_latest_version() {

	return @file_get_contents("http://mdcode.tech/scripts/downloads/JQuery_Chat_v.txt");

}

// Please leave this function alone
function latest_version() {

	$latest = get_latest_version();
	if($latest === false)
            return false;

	if(!version_compare(CURRENT_VERSION, $latest, '<')) {
	
		return true;
	
	}
	
}
?>