<?php
session_start();

if(!isset($_SESSION['chat_user'])) {
	header("Location: login.php");
	die;
}

require("../config.php");

if($_SERVER['REQUEST_METHOD'] === "POST") {

	if($_POST['pass'] != $_POST['c_pass'])
		$error = "The two passwords do not match.";

	if(strlen($_POST['pass']) < 6)
		$error = "Passwords must be a minimum of 6 characters.";

	if(empty($_POST['pass']) || empty($_POST['c_pass']) || empty($_POST['cur_pass']))
		$error = "Please fill in all fields.";

	if(empty($error)) {

		include("../connect.php");
		require("functions.php");
		
		$user = mysqli_real_escape_string($connection, $_SESSION['chat_user']);
		$pass = Secure($_POST['cur_pass']);
		
		$sql = mysqli_query($connection, "SELECT `user` FROM `chat_users` WHERE `user` = '{$user}' AND `pass` = '{$pass}'");
        mysqli_close($connection);
		
		if(mysqli_num_rows($sql) == 0)
			$error = "Current password is incorrect.";
		
		if(empty($error)) {

			require("../functions.php");

			update_user(Secure($_POST['pass']));
			
		}

	}

}
?>
<!DOCTYPE html>
<html>

<head>

	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

	<title>MDCode | Chat</title>
	
	<link href="../css/bootstrap.css" rel="stylesheet" type="text/css" />
	<link href="../css/chat.css" rel="stylesheet" type="text/css" />

</head>

<body>
	
<h1 style="text-align: center;">MDCode Chat | User Panel</h1>
	
<div class="container">

	<div class="row">

		<div class="span8 offset2 well" style="position: relative; text-align: center;">
		
			<a href="../chat.php" class="btn btn-mini" style="position: absolute; top: 15px; left: 15px;">Back to Chat</a>
			
			<h3>Change Password</h3>
			
			<?php
			if(isset($error)) {
			
				echo "<div class='alert alert-error'><b>ERROR</b>: $error</div>";
				
			} else if(isset($_GET['update']) && $_GET['update'] == "yes") {
			
				echo "<div class='alert alert-success'><b>SUCCESS</b>: Chat settings upated successfully!</div>";
				
			}
			?>

			<form method="post">

				<input type="password" class="span3" name="pass" placeholder="New Password">
				<input type="password" class="span3" name="c_pass" placeholder="Confirm Password">
				
				<input type="password" class="span3" name="cur_pass" placeholder="Current Password">
				
				<button type="submit" name="submit" class="btn btn-inverse btn-block">Change Password</button><br>
				
			</form>
		
		</div>

	</div>

</div>

</body>
</html>