<?php
if($_SERVER['REQUEST_METHOD'] === "POST") {

	require("../functions.php");
	
	$user = filter($_POST['user'], false);

	if(preg_match('/[^a-zA-Z]/', $user))
		$error = "Username must contain all letters and be appropriate.";
		
	if(strlen($_POST['user']) > 20)
		$error = "Please limit your username to 20 characters.";

	if(strlen($_POST['pass']) < 6)
		$error = "Password must be a minimum of 6 characters.";
		
	if($_POST['pass'] != $_POST['c_pass'])
		$error = "The two passwords do not match.";

	if(empty($_POST['user']) || empty($_POST['pass']) || empty($_POST['c_pass']))
		$error = "Please fill in all fields.";
		
	if(empty($error)) {
	
		require("functions.php");
		$salt = install();
		
		$fopen = fopen("../chat/functions.php", 'w') or die("Unable to write the functions.php file - chat/ directory.  Please check file permissions.");
		
		fwrite($fopen, '<?php
// Function to salt and hash passwords
function Secure($pass) {

	$algorithm = "whirlpool";

	$password = $pass."'.$salt.'";

	$password = hash($algorithm,$password);

	return $password;

}

?>');

	require("../chat/functions.php");
	include("../connect.php");
	
	$user = mysqli_real_escape_string($connection, $_POST['user']);
	$pass = Secure($_POST['pass']);
		
	$sql = mysqli_query($connection, "INSERT INTO `chat_users` VALUES ('{$user}', '{$pass}',  '1')");
	
	$success = 1;

	}

}
?>
<!DOCTYPE html>
<html>

<head>

	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

	<title>MDCode | Chat Installation</title>
	
	<link href="../css/bootstrap.css" rel="stylesheet" type="text/css" />
	<link href="../css/chat.css" rel="stylesheet" type="text/css" />

</head>

<body>

<h1 style="text-align: center; color: blue;">MDCode | Chat Installation - Step 2</h1>
	
<div class="container">

	<div class="row">

		<div class="span8 well" style="text-align: center; margin-left: 150px;">
		
			<h3>Create Admin User</h3>
			
			<?php
			if(isset($error)) {
			
				echo "<div class='alert alert-error'><b>ERROR</b>: $error</div>";
				
			}
			
			if(isset($success)) {
			
				echo "<div class='alert alert-success'><b>SUCCESS</b>: Congratulations!  You&#39;re ready to use your chat.<br /><a href='../chat/login.php' class='btn btn-primary'>Login</a></div>";
			
			} else {
			?>

			<form method="post">

				<input type="text" class="span6" name="user" placeholder="Username" value="<?php echo (isset($_POST['user']) ? htmlentities($_POST['user']) : ''); ?>">
				<input type="password" class="span6" name="pass" placeholder="Password" value="<?php echo (isset($_POST['pass']) ? htmlentities($_POST['pass']) : ''); ?>">
				<input type="password" class="span6" name="c_pass" placeholder="Confirm Password" value="<?php echo (isset($_POST['c_pass']) ? htmlentities($_POST['c_pass']) : ''); ?>">

				<button type="submit" class="btn btn-inverse btn-block">Add User</button>
				
			</form>
			
			<?php
			}
			?>
		
		</div>

	</div>

</div>

</body>
</html>