$(function() {

  $("#chat_text").keydown(function(event) {  

    var key = event.which;

    if (key <= 33) {

      if(key == 13) {
        event.preventDefault();
      }

      var maxLength = $(this).attr("maxlength");  
      var length = this.value.length;  

      if (length >= maxLength) {  
        event.preventDefault();  
      }  

    }  

  });

  $('#chat_text').keyup(function(e) {	

    e.preventDefault();

    if (e.keyCode == 13) {

      var text = $(this).val();
      var token = $("#token").val();

      if(token != "") {
        SpamAttempt();
        return false;
      }

      var maxLength = $(this).attr("maxlength");  
      var length = text.length;

      if (length <= maxLength + 1) {
        chat.send(text);
        $(this).val("");
      } else {
        $(this).val(text.substring(0, maxLength));
      }

    }
            
  });
            
});